/*
  Copyright (c) Grame 2012

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.
    
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.
    
    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Grame Research Laboratory, 9, rue du Garet 69001 Lyon - France
    research@grame.fr

*/

#ifndef __markers__
#define __markers__

#include "guidoelement.h"
#include "ARTag.h"

namespace guido 
{

/*!
\addtogroup operations
@{
*/

/*!
\brief tools for marking tags.
*/
class markers 
{
    public:
		enum { kNoMark, kClosed=-1, kOpenedBegin=1, kOpenedEnd=2};
		
		/// mark an element with an 'opened' attribute, taking care of its current openness
		static  void	markOpened  ( Sguidotag& elt, bool end=true );
		/// set an element 'opened' attribute whatever its current status
		static  void	setMark		( Sguidotag& elt, int type );
		/// set an element 'opened' attribute whatever its current status
		static  void	setMark		( Sguidoelement& elt, int type );
		/// delete the 'opened' attribute
		static  void	delMark		( Sguidotag& elt );
		/// gives the 'opened' attribute value
		static  int		opened		( Sguidotag& elt );
};

/*! @} */

}

#endif
